#include <stdio.h>

/*
-------------------------------------------------------------------------------
Propagacio a terra de la contaminacio radioactiva
-------------------------------------------------------------------------------
Dades: dt (mida del pas en dies), imax (passos que es volen calcular), jmax
       (nombre d'iteracions per estabilitzar), ym (densitat de vegetacio),
       crei (tant per u de creixement diari).
Resultats: Al fitxer "cesi1.dat". Cada fila representa un instant de temps
           La primera columma es el temps en dies. La segona la concentracio.
           La tercera la precipitacio i la quarta l'activitat total a les 
           plantes en Bq/kg.
Dades de prova: Hi ha una situacio ja plantejada a les matrius 'preci' i
                'conc'. Amb els valors dt=0.05 imax=560 jmax=2 ym=1 crei=0 ==>
                ... ... ... ...
                2.05 2.2 0 5.72448
                2.1 2.2 0 11.4405
                2.15 2.2 0 17.148
                2.2 2.2 0 22.8471
                ... ... ... ...
Observacions: No n'hi ha prou amb que les unitats d'entrada siguin coherents.
              Les unitats venen fixades per les unitats de les variables que
              son a dins del programa.
              Tan sols el valor jmax=1 es justificable des del punt de vista
              teoric.
-------------------------------------------------------------------------------
*/



main()
{

int i,j,k,l,imax,jmax,dia;
float dx[4],x0[4],x[4],xf[4],xm[4],font[4],mat[4][4],preci[41],conc[41],
        dt,t0,t,tf,tm,cont,x4,
        depo,ym,crei,ji,pluja;
FILE *arxiu;

printf("Tamany del pas en dies: ");
scanf("%f",&dt);
printf("Passos que vols calcular: ");
scanf("%d",&imax);
printf("Iteracions per estabilitzar: ");
scanf("%d",&jmax);
printf("Densitat de la vegetacio en Kg/m2: ");
scanf("%f",&ym);
printf("Quin factor creix per dia: ");
scanf("%f",&crei);
arxiu=fopen("cesi2.dat","w");
/* Suposem que inicialment no hi ha contaminacio */
for(k=0;k<4;k++)x0[k]=0.0;
t0=0;
/* Inicialitzem MAT i FONT ... */
for(k=0;k<4;k++)for(l=0;l<4;l++)mat[k][l]=0.0;
for(k=0;k<4;k++)font[k]=0.0;
/* ... i les omplim amb parametres empirics */
mat[0][0]=-6.33e-5-6.65e-4-8.64e-5;
mat[1][0]=6.65e-4;
mat[1][1]=-6.33e-5-1.73e-4;
mat[2][1]=1.73e-4;
mat[2][2]=-6.33e-5;
mat[3][0]=8.64e-5;
/* Aqui modelitzem la situacio atmosferica */
preci[1]=0.0;
preci[2]=0.0;
preci[3]=0.0;
preci[4]=0.0;
preci[5]=0.0;
preci[6]=0.0;
preci[7]=0.0;
preci[8]=0.0;
preci[9]=0.0;
preci[10]=0.0;
preci[11]=18.0;
preci[12]=2.0;
preci[13]=2.5;
preci[14]=3.0;
preci[15]=1.0;
preci[16]=0.0;
preci[17]=5.0;
preci[18]=0.0;
preci[19]=0.0;
preci[20]=0.0;
preci[21]=0.0;
preci[22]=1.0;
preci[23]=1.0;
preci[24]=0.0;
preci[25]=7.0;
preci[26]=0.0;
preci[27]=0.0;
preci[28]=0.0;
preci[29]=0.0;
preci[30]=0.0;
conc[1]=0.0;
conc[2]=0.0;
conc[3]=2.2;
conc[4]=1.8;
conc[5]=0.0;
conc[6]=0.0;
conc[7]=0.1;
conc[8]=0.7;
conc[9]=0.2;
conc[10]=0.1;
conc[11]=0.4;
conc[12]=0.0;
conc[13]=0.0;
conc[14]=0.0;
conc[15]=0.0;
conc[16]=0.0;
conc[17]=0.0;
conc[18]=0.0;
conc[19]=0.0;
conc[20]=0.0;
conc[21]=0.0;
conc[22]=0.0;
conc[23]=0.0;
conc[24]=0.0;
conc[25]=0.0;
conc[26]=0.0;
conc[27]=0.0;
conc[28]=0.0;
conc[29]=0.0;
conc[30]=0.0;
/* Ara inicialitzem les matrius */
for(i=0;i<4;i++)
	{
	x[i]=x0[i];
	xf[i]=x0[i];
	}
t=t0;
for(i=0;i<imax;i++)   
   {
   tm=t+dt/2.0;
   dia=1 + (int) tm;
   pluja=preci[dia];
   ji=conc[dia];
   depo=ji*(pluja*3600.0*1.0e3*1.64e-4+2.4e-3*3600.0*24.0);
   mat[0][3]=3.0e-2+3.4e-2*pluja;
   font[0]=depo*0.75;
   mat[3][3]=-6.33e-5-3.0e-2+3.4e-2*pluja-crei;
   font[3]=depo*0.25;
   for(j=0;j<jmax;j++)
      {
      for(k=0;k<4;k++)xm[k]=(x[k]+xf[k])/2.0;
      for(k=0;k<4;k++)
         {		
         cont=0.0;
         for(l=0;l<4;l++)cont=cont+mat[k][l]*xm[l];
         cont=cont+font[k];
         dx[k]=cont*dt;
         xf[k]=x[k]+dx[k];
         }         
      }
   for(k=0;k<4;k++)x[k]=xf[k];
   t=t+dt;         
/* Fem el calcul estatic, tambe amb parametres empirics */
   x4=(2.0e-2)*(x[0]/13.0+x[1]/52.0); 
/* I ho treiem per fitxer */
   fprintf(arxiu,"%g %g %g %g\n",t,ji,pluja,x[3]/ym+x4);
   }
fclose(arxiu);
}
